# Fixme: unbundle libi?; run tests
# Also no source for doc (not in repo).

Name:       mrnet
Summary:    Multicast Reduction Network
Version:    5.0.1
Release:    4%{?dist}
License:    LGPLv2
Group:      System Environment/Libraries
URL:        http://paradyn.org/mrnet
Source0:    %{name}_%{version}.tar.gz
# http://git.dyninst.org/?p=mrnet.git;a=blob_plain;f=conf/configure.in;hb=5775c9d0d0a976d2635d34e3b2106960102f24ab
Source1:    mrnet-configure.in
Patch1:	    mrnet-install.patch
# Fix package version and shared lib names
# http://git.dyninst.org/?p=mrnet.git;a=patch;h=261b06d76051eda1f311a9f5b4d609578830688a
Patch2:     mrnet-version.patch
# fix soname
# http://git.dyninst.org/?p=mrnet.git;a=patch;h=e99f7a723a16c2794e9dfbb3cbe0cc4511942efb
Patch3:     mrnet-soname.patch
# Fix build on f29
Patch4:	    mrnet-decl.patch
BuildRequires: gcc-c++ boost-devel
# necessary on epel7
BuildRequires: libstdc++-devel libstdc++-static

%{?filter_setup:
%filter_from_requires /lib\(mrnet\|xplat\).*/d
%filter_setup
}

# configure removes -g (why?), so debuginfo package not useful
%define debug_package %{nil}

%description
MRNet is a software overlay network that provides efficient multicast
and reduction communications for parallel and distributed tools and
systems.  MRNet uses a tree of processes between the tool's front-end
and back-ends to improve group communication performance.  These
internal processes are also used to distribute many important tool
activities, reducing data analysis time and keeping tool front-end
loads manageable.

MRNet-based tool components communicate across logical channels called
streams.  At MRNet internal processes, filters are bound to these
streams to synchronize and aggregate dataflows.  Using filters, MRNet
can efficiently compute averages, sums, and other more complex
aggregations and analyses on tool data.  MRNet also supports facilities
that allow tool developers dynamically load new tool-specific filters
into the system.

%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:       boost-devel

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
# whence the magic number?
%setup -q -n %{name}-3093918
# -n in case it gets shipped in future
cp -n %SOURCE1 conf/configure.in
%patch1 -p1 -b .inst
# %patch2 -p1
# %patch3 -p1
%patch4 -p1
#chmod -x doc/*
rm -r external/boost
iconv -f iso8859-1 -t utf-8 README > README-t && mv README-t README
iconv -f iso8859-1 -t utf-8 LICENSE > LICENSE-t && mv LICENSE-t LICENSE


%build
# --disable-static doesn't avoid static linking
%configure --enable-shared --enable-verbosebuild
make %{?smp_flags} CURRENT_PLATFORM=%_host

%install
make install DESTDIR=$RPM_BUILD_ROOT CURRENT_PLATFORM=%_host
make install-examples DESTDIR=$RPM_BUILD_ROOT CURRENT_PLATFORM=%_host
mv $RPM_BUILD_ROOT%_libdir/mrnet-*/include/* $RPM_BUILD_ROOT%_includedir/mrnet
mv $RPM_BUILD_ROOT%_libdir/xplat-*/include/* $RPM_BUILD_ROOT%_includedir/xplat
rm -rf $RPM_BUILD_ROOT%_libdir/mrnet-* $RPM_BUILD_ROOT%_libdir/xplat-*
# remove built examples
rm $RPM_BUILD_ROOT%_bindir/[A-Z]* $RPM_BUILD_ROOT%_libdir/[A-Z]*

%check
# running tests looks as if it requires multiple hosts
#make tests


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%doc ACKNOWLEDGMENTS LGPL-2.1 LICENSE README
%_libdir/*.so.*
%_bindir/*

%files devel
%_includedir/*
%exclude %_libdir/*.a*
%_libdir/*.so


%changelog
* Sat Nov 10 2018 Dave Love <loveshack@fedoraproject.org> - 5.0.1-4
- Fix build on f29

* Fri Oct  7 2016 Dave Love <loveshack@fedoraproject.org> - 5.0.1-2
- BR libstdc++-static as configure --disable-static doesn't work

* Mon Jan 25 2016 Dave Love <loveshack@fedoraproject.org> - 5.0.1-1
- New version
- Don't install .a

* Sun Sep 21 2014 Dave Love <d.love@liverpool.ac.uk> - 4.1.0-3
- Don't install built examples or second copy of libraries
- Fix non-utf-8 README, LICENSE
- Fix versioning and missing configure.in
- Remove external/boost in prep

* Sat Sep  6 2014 Dave Love <d.love@liverpool.ac.uk> - 4.1.0-2
- Move headers out of libdir

* Sat May  3 2014 Dave Love <d.love@liverpool.ac.uk> - 4.1.0-1
- Update to 4.1.0

* Sun Mar  9 2014 Dave Love <d.love@liverpool.ac.uk> - 4.0.0-2
- Add library sonames
- Adjust for supporting rpms
- Modify module file

* Tue Feb 25 2014 Dave Love <d.love@liverpool.ac.uk> - 4.0.0-1
- Initial packaging
